<template lang="pug">
    v-card
        v-card-title Matrix
        v-card-text
            div.row
                v-autocomplete(
                    label="Above"
                    v-model="aboveBelows.aboves"
                    :items="searchAbovesContexts"
                    :search-input.sync="searchAboves"
                    chips
                    deletable-chips
                    multiple
                    cache-items
                    hide-selected
                )
            div.row
                | This context is: {{contextNumber}}
            div.row
                v-autocomplete(
                    label="Below"
                    v-model="aboveBelows.belows"
                    :items="searchBelowsContexts"
                    :search-input.sync="searchBelows"
                    chips
                    deletable-chips
                    multiple
                    cache-items
                    hide-selected
                )
</template>

<script>
import { debounce } from "debounce";
import { mapActions, mapGetters } from "vuex";
export default {
    name: "contextMatrix",
    props: {
        contextNumber: {
            required: true
        },
        aboveBelows: {
            required: true,
            type: Object
        }
    },
    data: function() {
        return {
            localAboveBelows: null,
            searchBelowsContexts: [],
            searchBelows: "",
            searchAbovesContexts: [],
            searchAboves: ""
        };
    },
    mounted: function() {
        this.localAbovesBelows = this.aboveBelows;
    },
    computed: {
        ...mapGetters({
            getATrench: "trench/getATrench"
        })
    },
    methods: {
        ...mapActions({
            fetchAllSearch: "search/fetchAllSearch"
        }),
        remove: function(array, item) {
            const index = this[array].indexOf(item.text);
            if (index >= 0) {
                this[array].splice(index, 1);
            }
        },
        valueChanged: function() {
            this.$emit("input", {
                context: "AboveBelows",
                data: this.localAboveBelows
            });
        },
        grabChange: function(element, value) {
            this.localAboveBelows[element] = value;
            this.valueChanged();
        }
    },
    watch: {
        searchBelows: debounce(function() {
            if (!this.searchBelows || this.searchBelows.trim() === "") {
                return [];
            }
            this.fetchAllSearch({
                url: this.getATrench.data.relationships.contexts.links.related,
                options: {
                    params: {
                        likenumber: this.searchBelows
                    }
                }
            }).then(response => {
                if (!response.data) {
                    return [];
                }
                this.searchBelowsContexts = response.data
                    .filter(el => {
                        return !this.aboveBelows.aboves.includes(el.id);
                    })
                    .map(el => {
                        return {
                            text: el.attributes.number.toString(),
                            value: el.id
                        };
                    });
            });
        }, 500),
        searchAboves: debounce(function() {
            if (!this.searchAboves || this.searchAboves.trim() === "") {
                return [];
            }
            this.fetchAllSearch({
                url: this.getATrench.data.relationships.contexts.links.related,
                options: {
                    params: {
                        likenumber: this.searchAboves
                    }
                }
            }).then(response => {
                if (!response.data) {
                    return [];
                }
                this.searchAbovesContexts = response.data
                    .filter(el => {
                        return !this.aboveBelows.belows.includes(el.id);
                    })
                    .map(el => {
                        return {
                            text: el.attributes.number.toString(),
                            value: el.id
                        };
                    });
            });
        }, 500)
    }
};
</script>
